<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="路径编号" prop="pathCode">
              <el-select v-model="queryParams.pathCode" placeholder="请选择路径编号" clearable filterable>
                <el-option v-for="item in pathList" :key="item.objId" :label="`${item.pathCode} / ${item.pathName}`" :value="item.pathCode" />
              </el-select>
            </el-form-item>
            <el-form-item label="起点" prop="startPoint">
              <el-input v-model="queryParams.startPoint" placeholder="请输入起点" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="终点" prop="endPoint">
              <el-input v-model="queryParams.endPoint" placeholder="请输入终点" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="是否标识" prop="isFlag">
              <el-select v-model="queryParams.isFlag" placeholder="请选择是否标识" clearable>
                <el-option v-for="dict in wcs_is_flag" :key="dict.value" :label="dict.label" :value="parseInt(dict.value)" />
              </el-select>
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['wcs:pathDetails:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['wcs:pathDetails:edit']"
              >修改</el-button
            >
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['wcs:pathDetails:remove']"
              >删除</el-button
            >
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['wcs:pathDetails:export']">导出</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="pathDetailsList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="序号" align="center" type="index" width="60" />
        <el-table-column label="路径编号" align="center" prop="pathCode" />
        <el-table-column label="起点" align="center" prop="startPoint" />
        <el-table-column label="终点" align="center" prop="endPoint" />
        <el-table-column label="是否标识" align="center" prop="isFlag">
          <template #default="scope">
            <dict-tag :options="wcs_is_flag" :value="scope.row.isFlag" />
          </template>
        </el-table-column>
        <el-table-column label="备注" align="center" prop="remark" />
        <el-table-column label="创建时间" align="center" prop="createTime" width="100">
          <template #default="scope">
            <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="创建人" align="center" prop="createByName" width="100" />
        <el-table-column label="更新人" align="center" prop="updateByName" width="100" />
        <el-table-column label="操作" align="center" fixed="right" class-name="small-padding fixed-width" width="120">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['wcs:pathDetails:edit']"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['wcs:pathDetails:remove']"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>

    <el-dialog :title="dialog.title" v-model="dialog.visible" width="600px" append-to-body>
      <el-form ref="pathDetailsFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="路径编号" prop="pathCode">
          <el-select v-model="form.pathCode" placeholder="请选择路径编号" clearable filterable class="w-full">
            <el-option v-for="item in pathList" :key="item.objId" :label="`${item.pathCode} / ${item.pathName}`" :value="item.pathCode" />
          </el-select>
        </el-form-item>
        <el-form-item label="起点" prop="startPoint">
          <el-input v-model="form.startPoint" placeholder="请输入起点" />
        </el-form-item>
        <el-form-item label="终点" prop="endPoint">
          <el-input v-model="form.endPoint" placeholder="请输入终点" />
        </el-form-item>
        <el-form-item label="是否标识" prop="isFlag">
          <el-radio-group v-model="form.isFlag">
            <el-radio v-for="dict in wcs_is_flag" :key="dict.value" :value="parseInt(dict.value)">{{ dict.label }}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="PathDetails" lang="ts">
import { listPathDetails, getPathDetails, delPathDetails, addPathDetails, updatePathDetails } from '@/api/wcs/pathDetails';
import { PathDetailsVO, PathDetailsQuery, PathDetailsForm } from '@/api/wcs/pathDetails/types';
import { getPathInfoList } from '@/api/wcs/pathInfo';
import { PathInfoVO } from '@/api/wcs/pathInfo/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { wcs_is_flag } = toRefs<any>(proxy?.useDict('wcs_is_flag'));

const pathDetailsList = ref<PathDetailsVO[]>([]);
const pathList = ref<PathInfoVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const pathDetailsFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: PathDetailsForm = {
  objId: undefined,
  pathCode: undefined,
  startPoint: undefined,
  endPoint: undefined,
  isFlag: 1,
  remark: undefined,
  createTime: undefined
};
const data = reactive<PageData<PathDetailsForm, PathDetailsQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    pathCode: undefined,
    startPoint: undefined,
    endPoint: undefined,
    isFlag: undefined,
    params: {}
  },
  rules: {
    pathCode: [{ required: true, message: '路径编号不能为空', trigger: 'change' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

const getList = async () => {
  loading.value = true;
  try {
    const res = await listPathDetails(queryParams.value);
    pathDetailsList.value = res.rows;
    total.value = res.total;
  } finally {
    loading.value = false;
  }
};

const loadPathList = async () => {
  try {
    // 下拉接口只按启用状态取可选路径，避免为补分页字段而使用 any。
    const res = await getPathInfoList({ isFlag: 1, params: {} });
    pathList.value = res.data || [];
  } catch {
    proxy?.$modal.msgError('获取路径信息下拉列表失败');
  }
};

const cancel = () => {
  reset();
  dialog.visible = false;
};

const reset = () => {
  form.value = { ...initFormData, isFlag: 1 };
  pathDetailsFormRef.value?.resetFields();
};

const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

const handleSelectionChange = (selection: PathDetailsVO[]) => {
  ids.value = selection.map((item) => item.objId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

const handleAdd = async () => {
  reset();
  await loadPathList();
  dialog.visible = true;
  dialog.title = '添加路径明细';
};

const handleUpdate = async (row?: PathDetailsVO) => {
  reset();
  await loadPathList();
  const _objId = row?.objId || ids.value[0];
  const res = await getPathDetails(_objId);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改路径明细';
};

const submitForm = () => {
  pathDetailsFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      try {
        if (form.value.objId) {
          await updatePathDetails(form.value);
        } else {
          await addPathDetails(form.value);
        }
        proxy?.$modal.msgSuccess('操作成功');
        dialog.visible = false;
        await getList();
      } finally {
        buttonLoading.value = false;
      }
    }
  });
};

const handleDelete = async (row?: PathDetailsVO) => {
  const _objIds = row?.objId || ids.value;
  try {
    await proxy?.$modal.confirm('是否确认删除路径明细编号为"' + _objIds + '"的数据项？');
    await delPathDetails(_objIds);
    proxy?.$modal.msgSuccess('删除成功');
    await getList();
  } catch (e) {
    if (e !== 'cancel' && e !== 'close') {
      proxy?.$modal.msgError('删除路径明细失败');
    }
  }
};

const handleExport = () => {
  proxy?.download(
    'wcs/pathDetails/export',
    {
      ...queryParams.value
    },
    `pathDetails_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
  loadPathList();
});
</script>
